!> \file
!! Contains subroutine init_gravity()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine INIT_GRAVITY
!
!> Initialises all the gravity parameters and variables.
!<
subroutine init_gravity

  use unites
  use gravity

  implicit none

  namelist/poisson/ISOLE,gravity_type,gravity_params

  !Default values for "poisson" namelist
  ISOLE          = 1  
  gravity_type   = 0
  gravity_params = (/ 0.,0.,0.,0. /)

  open  (2,file='liste.nml')
  rewind(2                 )
  read  (2,NML=poisson     )
  close (2                 )

  select case (gravity_type)
  case(2) ! Point source potential
     gravity_params(1)=gravity_params(1)*gramme
     gravity_params(2)=gravity_params(2)*centimetre
     gravity_params(3)=gravity_params(3)*centimetre
     gravity_params(4)=gravity_params(4)*centimetre
  case(3) ! Constant gravitational field
     gravity_params(1)=gravity_params(1)*centimetre/seconde**2
     gravity_params(2)=gravity_params(2)*centimetre/seconde**2
     gravity_params(3)=gravity_params(3)*centimetre/seconde**2
  end select

  return
  
end subroutine init_gravity
