!> \file
!! Contains subroutine film_hdf()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine FILM_HDF
!
!> Writes hdf5 frames to create a movie.
!<
subroutine film_hdf(kk)

#if HDF==1

  use hdf5
  use parameters, only : nx,ndim,nx_glob,nx_cpu,nbuf
  use var       , only : rho,e,rhou,fx
  use geom      , only : x_glob,nshift_gr
  use gammas
  use divers    , only : mu,verbose,temps
  use para      , only : mype,ncpu,x_start,x_start_cpu
  use unites    , only : gramme,cm3,erg
  use mfilm     , only : t_film,dt_film,ifilm,nl1,nl2,nl3

  implicit none

#if PARA==1
  include 'mpif.h'
#endif

  integer :: i,j,k,idim,ncount,iproc,req1,req2,tag1,tag2,ierr,kk
  integer :: jg,kg,destination,emetteur
  real    :: fmax,fmin, eps,rhou2,pp,u2

#if PARA==1
  integer, dimension(mpi_status_size) :: statut
#endif

  if (temps < t_film) return

  if(mype==0) call wrt_main_h5(kk)
  call wrt_film_h5(ifilm)

  ifilm   = ifilm   + 1
  t_film  = max(temps+dt_film, t_film+dt_film)

  if (verbose) write(*,*) 'end of subroutine film_hdf.f90'

  return

#else

  use para, only : mype

  implicit none

  integer :: kk

  call close_program(mype,'hdf5 dummy: film_hdf')
  
#endif

end subroutine film_hdf
