!> \file
!! Contains subroutine wrt_film_h5()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine WRT_FILM_H5
!
!> Writes the hdf5 output frames to create a movie.
!<
subroutine wrt_film_h5(k)

  use para, only : mype

#if HDF==1

  use divers
  use mfilm , only : t_film

  implicit none

  integer,dimension(8) :: dataexist     !< Data buffers 
  integer              :: k
  
  character(len=33) :: filename 

  call get_dataexist(datanames,ndata,dataexist)

  call get_filename(filename,'-f-000_000.h5',t_film,k,mype)
  if (mype==0) write(*,*) 'Writing file :',filename

  call output_data(filename,dataexist)

  return

#else

  implicit none

  integer :: k

  call close_program(mype,'hdf5 dummy: wrt_film_h5')

#endif

end subroutine wrt_film_h5
