!> \file
!! Contains subroutine cpu()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine CPU
!
!> Performs the domain decomposition among the
!! different cpus.
!<
subroutine cpu

  use para      , only : ncpu,ncpu_x,ncpu_y,ncpu_z,mype
  use parameters, only : ndim,nx_glob

  implicit none

  integer                   :: i
  integer, dimension(ndim ) :: Cpu_Dim,NN

  do i=1,ndim
     NN(i) = nx_glob(i)
  enddo

  call CpuDec(Ncpu,Cpu_dim,NN)

  ncpu_x = cpu_dim(1)
  ncpu_y = 1 ; if (ndim > 1) ncpu_y = cpu_dim(2)
  ncpu_z = 1 ; if (ndim > 2) ncpu_z = cpu_dim(3)

  if (ncpu_x*ncpu_y*ncpu_z .ne. ncpu ) then
     write(*,*) 'ncpu_x*ncpu_y*ncpu_z =' , ncpu_x*ncpu_y*ncpu_z   
     write(*,*) 'ncpu                 =' , ncpu
     call close_program(mype,'called from CPU_')
  endif
     
  return
  
end subroutine cpu
