!> \file
!! Contains subroutine allocate_array_ray()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine ALLOCATE_ARRAY_RAY
!
!> Allocates the arrays used for the M1 radiative transfer.
!<
subroutine allocate_array_ray

  use parameters
  use varray
  use varold    , only : Tgazold
  use var       , only : tgaz
  use cl_ray

  implicit none

  ! allocate boundary condition arrays
  allocate(Er_l(     1:2*ndim))
  allocate(Fr_l(ndim,1:2*ndim))
  allocate(Tr_l(     1:2*ndim))

  ! allocate the varold
  allocate(    Tgazold(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)       ))
  allocate(    Erayold(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)       ))
  allocate(    Frayold(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3),1:ndim))

  ! allocate the var
  allocate(       Tgaz(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)       ))
  allocate(       Eray(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)       ))
  allocate(       Fray(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3),1:ndim))

  ! allocate the opacity variables 
  allocate(kappa_emi_ray(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)))
  allocate(kappa_abs_ray(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)))
  allocate(kappa_sca_ray(nxmin(1):nxmax(1),nxmin(2):nxmax(2),nxmin(3):nxmax(3)))

  return
  
end subroutine allocate_array_ray
