!> \file
!! Contains subroutine initVarGmres()
!<

!###########################################################
!###########################################################
!###########################################################
!###########################################################

!  Subroutine INITVARGMRES
!
!> Initialises all the M1 parameters and variables used by
!! the GMRES matrix inversion algorithm.
!<
subroutine initVarGmres()
    
  use parameters
  use VarGmres
  use tabgmres
  
  namelist/gmres/ restart,itermax,TypePrecond,TypeOrtho

  integer :: TypePrecond,TypeOrtho,nloc

  call init_dgmres(icntl,cntl)

  ! tolerance
  cntl(1) = 1.d-5
  ! Parameters for the backward error computation
  cntl(2) = 0.
  cntl(3) = 1.
  cntl(4) = 0.
  cntl(5) = 1.

  ! Save the convergence history
  icntl(2) = 30
  icntl(3) = 20

  ! supply initial guess
  icntl(6) = 1

  ! Default values of gmres namelist
  restart=20
  itermax=300
  TypePrecond=0
  TypeOrtho=2

  open  (1,file='liste.nml')
  rewind(1                 )
  read  (1,NML=gmres       )
  close (1                 )

  ! Maximum number of iterations
  icntl(7) = itermax

  ! preconditioning : 0=none, 1=left, 2=right
  icntl(4) = TypePrecond
  icntl(5) = TypeOrtho

  ! allocate workspace arrays
  nloc=(nx(1)*nx(2)*nx(3))*nvar_ray
  lwork=restart*restart+restart*(nloc+5)+5*nloc+1 
  allocate(work(lwork))
  allocate(workred(-nvar_ray+1:(imax-imin+(jmax-jmin)*(imax-imin+1)+(kmax-kmin)*(imax-imin+1)*(jmax-jmin+1))*nvar_ray))
  
  return

end subroutine initVarGmres
