!  Subroutine CAL_KAPPA_DIF
!
!> Computes the absorption \f$ \kappa_{a} \f$ and
!! scattering \f$ \kappa_{s} \f$ opacities for the FLD.
!<
subroutine cal_kappa_dif(rho,Tgaz,kappa_abs_dif,kappa_sca_dif,nxmin,nxmax,nymin,nymax,nzmin,nzmax)

  use unites
  use shock

  implicit none

  integer :: nxmin,nxmax,nymin,nymax,nzmin,nzmax
  real, dimension(nxmin:nxmax,nymin:nymax,nzmin:nzmax) :: rho,Tgaz,kappa_abs_dif,kappa_sca_dif

  if(shock_type .eq. 'stat') then
     kappa_abs_dif = 4.0e4 *centimetre**2/gramme
  else
     kappa_abs_dif = 3.1e-10 /centimetre / rho
  endif

  kappa_sca_dif = 0.0e+00

  return

end subroutine cal_kappa_dif
