pro self_gravity, ps=ps

;Read heracles solution
RESOLVE_ROUTINE,'rd',/COMPILE_FULL_FILE
rd,1,var
x=var.mesh.xc
phi=var.E(*,50,50)

G = 6.67E-8
M = 1.9891E33
R = 2.5*1000*100

phi_ana=dblarr(100)

for i=0,99 do begin
d=abs(x(i)-500000)
if d lt 250000 then begin
phi_ana(i)=G*M/(2*R)*((x(i)-500000)^2/R^2-3)
endif else begin 
phi_ana(i)=-G*M/abs(x(i)-500000)
endelse
endfor

if keyword_set(ps) then begin
  set_plot, 'ps' ; Set plotting to PostScript.
  device, /color, bits=8, xsize=12, ysize=8, /inches, filename='self_gravity.ps' ; Set the filename.
endif

tek_color
loadct,5
if not keyword_set(ps) then window,0
plot,x,phi,psym=4,xtitle='x',title='potential'
oplot,x,phi_ana,thick=3,color=120

; diff=abs(phi-phi_ana)/abs(phi_ana)
; print,'minmax error: ', minmax(diff)

if keyword_set(ps) then begin
  device, /close ; Close the file. 
  set_plot,'x'
endif

return
end
