from data  import rd_heracles

from pylab import *

def shock(shock_type='stat',dir='x',multigroup=0,fld=0,save=0):

    Lbox_min=0.

    var1=rd_heracles.HeraclesData(1,'bin')

    if shock_type=='stat':
        subplot(221)
        plot1d_xcenter(var1,type='rho',slice=dir)
        if dir=='x':
            subplot(222)
            plot1d_xcenter(var1,type='vx',slice=dir)
            if fld==0:
                subplot(224)
                plot1d_xcenter(var1,type='Frx',slice=dir)
        elif dir=='y':
            subplot(222)
            plot1d_xcenter(var1,type='vy',slice=dir)
            if fld==0:
                subplot(224)
                plot1d_xcenter(var1,type='Fry',slice=dir)
        elif dir=='z':
            subplot(222)
            plot1d_xcenter(var1,type='vz',slice=dir)
            if fld==0:
                subplot(224)
                plot1d_xcenter(var1,type='Frz',slice=dir)

        if fld==0:
            subplot(223)
            plot1d_xcenter(var1,type='T',slice=dir)
            plot1d_xcenter(var1,type='Tr',slice=dir)
        elif fld==1:
            subplot(223)
            plot1d_xcenter(var1,type='T',slice=dir)
            plot1d_xcenter(var1,type='Td',slice=dir)


    else:
        Lbox_min=8.e11
        if shock_type == 'sub':
            v=-6.e-5    # in units of 1.e5km/s
            axis([0.5,5,0,1200])
        elif shock_type == 'super':
            v=-20.e-5   # in units of 1.e5km/s
            axis([0.5,9,0,6000])

        var2=rd_heracles.HeraclesData(2,'bin')
        var3=rd_heracles.HeraclesData(3,'bin')

        plot1d_xchange(var1,type='T',slice=dir,Lbox_min=Lbox_min,v=v)
        plot1d_xchange(var2,type='T',slice=dir,Lbox_min=Lbox_min,v=v)
        plot1d_xchange(var3,type='T',slice=dir,Lbox_min=Lbox_min,v=v)

        if fld==0:
            plot1d_xchange(var1,type='Tr',slice=dir,Lbox_min=Lbox_min,v=v)
            plot1d_xchange(var2,type='Tr',slice=dir,Lbox_min=Lbox_min,v=v)
            plot1d_xchange(var3,type='Tr',slice=dir,Lbox_min=Lbox_min,v=v)
        elif fld==1:
            plot1d_xchange(var1,type='Td',slice=dir,Lbox_min=Lbox_min,v=v)
            plot1d_xchange(var2,type='Td',slice=dir,Lbox_min=Lbox_min,v=v)
            plot1d_xchange(var3,type='Td',slice=dir,Lbox_min=Lbox_min,v=v)

    if save==1:
        if multigroup==0:
            if fld==0:
                savefig(shock_type+'shock'+dir+'.eps')
            elif fld==1:
                savefig(shock_type+'shock'+dir+'_fld.eps')
        elif multigroup==1:
            savefig(shock_type+'shock'+dir+'_multig.eps')

    return

def plot1d_xcenter(data,type='rho',save=0,slice='x',xcut=0,ycut=0,zcut=0):

    #Get data
    if slice=='x':
        x=data.xcg
        data_x=data.get_slice_x(type,ycut,zcut)
    if slice=='y':
        x=data.ycg
        data_x=data.get_slice_y(type,xcut,zcut)
    if slice=='z':
        x=data.zcg
        data_x=data.get_slice_z(type,xcut,ycut)

    #Plot data
    xlabel(slice) ; ylabel(type)

    x0=0.5*(max(x)+min(x))
    plot(x-x0,data_x)

    return


def plot1d_xchange(data,type='rho',save=0,slice='x',xcut=0,ycut=0,zcut=0,Lbox_min=0.,v=0.):

    #Get data
    if slice=='x':
        x=data.xcg
        data_x=data.get_slice_x(type,ycut,zcut)
    if slice=='y':
        x=data.ycg
        data_x=data.get_slice_y(type,xcut,zcut)
    if slice=='z':
        x=data.zcg
        data_x=data.get_slice_z(type,xcut,ycut)

    #Plot data
    xlabel(slice) ; ylabel(type)

    x=(x-Lbox_min)/1.e10
    plot(x-v*data.time,data_x)

    return
