from data  import rd_heracles
from plots import snapshots

from pylab import *

def sod1d(dir='x',isotherm=0,save=0):

    var=rd_heracles.HeraclesData(1,'bin')

    #Read analytic solution
    if isotherm==1:
        f = loadtxt("../ref/sod1d_exact_isotherm.dat",skiprows=6)
        x_e=f[:,0] ; r_e=f[:,1] ; u_e=f[:,2]
    if isotherm==0:
        f = loadtxt("../ref/sod1d_exact.dat",skiprows=6)
        x_e=f[:,0] ; r_e=f[:,1] ; u_e=f[:,2] ; p_e=f[:,3] ; e_e=f[:,4]

    subplot(221)
    snapshots.plot1d(var,type='rho',slice=dir)
    plot(x_e,r_e,'r')
    subplot(222)
    if dir=='x':
        snapshots.plot1d(var,type='vx',slice=dir)
    if dir=='y':
        snapshots.plot1d(var,type='vy',slice=dir)
    if dir=='z':
        snapshots.plot1d(var,type='vz',slice=dir)
    plot(x_e,u_e,'r')

    if isotherm==0:
        subplot(224)
        snapshots.plot1d(var,type='P',slice=dir)
        plot(x_e,p_e,'r')

    if save==1:
        if isotherm==0:
            print 'tttt'
            savefig('sod1d'+dir+'.eps')
        if isotherm==1:
            savefig('sod1d'+dir+'_isoT.eps')

    return
